%define base_name qcg-ntf
%define _sourcedir %{_topdir}/SOURCES/%{base_name}

%{!?default_package_ext: %define default_package_ext tar.gz}
%{!?system_name: %define system_name 0}

Summary:	QCG Notification Provider
Name:		%{base_name}
Version:	3.4.0
Release:	10
License:	GPLv3 with exceptions
Group:		Applications/System
Source0:	%{name}-%{version}.%{default_package_ext}
Source1:	qcg-ntfd.init
Source2:	qcg-ntfd.logrotate
URL:		http://www.qoscosgrid.org/trac/qcg-notification
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	libtool
BuildRequires:	gcc >= 4.1
BuildRequires:  pkgconfig >= 0.9.0
BuildRequires:  glib2-devel >= 2.0.0
BuildRequires:  libxslt-devel >= 1.1.17
BuildRequires:	qcg-core-devel >= 3.4.0
BuildRequires:  qcg-curl-devel >= 7.25.0
BuildRequires:  qcg-curl >= 7.25.0
BuildRoot:	%{_tmppath}/%{name}-%{version}-root-%(id -u -n)
Requires:       postgresql-odbc >= 08.01.0200-3.1
Requires: 	libxslt >= 1.1.17
Requires:       qcg-core >= 3.4.0

%define         _qcgdir         %{_prefix}
%ifarch x86_64
%define         _libdir         %{_qcgdir}/lib64
%endif

%define         _qcgsysconfdir  %{_sysconfdir}/qcg/qcg-ntf
%define         _logrotatedir   %{_sysconfdir}/logrotate.d

%define         _depdir         /opt/qcg/dependencies

%description
QCG-Notification service.
%package xmpp-publisher-plugin
Summary:	XMPP publisher plugin for QCG-Notification service
Group:		Applications/System
Requires:       %{name} = %{version}-%{release}
Requires:	qcg-loudmouth >= 1.4.3-1

%description xmpp-publisher-plugin
XMPP (jabber) publisher plugin for QCG-Notification service.

%package smtp-publisher-plugin
Summary:	SMTP publisher plugin for QCG-Notification service
Group:		Applications/System
Requires:       %{name} = %{version}-%{release}
Requires:	qcg-curl >= 7.25.0

%description smtp-publisher-plugin
SMTP (e-mail) publisher plugin for QCG-Notification service.

%package devel
Summary:	Development files for qcg-ntf modules
Group:		Development/System
Requires:       %{name} = %{version}-%{release}

%description devel
Header files for qcg-ntf modules.

%package client
Summary:        Text-based client program for QCG-Notification Provider
Group:		Applications/System
Requires:  	qcg-core >= 3.2.0

%description client
Text-based client program for the QCG-Notification service. 

%package consumer
Summary:        Text-based consumer program for QCG-Notification Provider
Group:		Applications/System
Requires:  	qcg-core >= 3.2.0


%description consumer
Text-based consumer program for the QCG-Notification service. 

%package logrotate
Summary:	Logrotate configuration for QCG-Notification service
Group:		Applications/System
Requires:       %{name} = %{version}-%{release}

%description logrotate
logrotate configuration for QCG-Notification service.

%prep
%setup -q

%build
%{!?configure_options: %define configure_options %{nil}} 

rm -f m4/libtool.m4 m4/ltoptions.m4 m4/ltsugar.m4 m4/ltversion.m4 m4/lt~obsolete.m4
%{__libtoolize} --copy --force
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake} -a -c -f --foreign
%configure \
	PKG_CONFIG_PATH=%{_depdir}/lib/pkgconfig:%{_libdir}/pkgconfig \
	--sysconfdir=%{_qcgsysconfdir} \
	--with-libcurl=%{_depdir} \
	--with-qcg-core=%{_qcgdir} \
	--with-xmpp-plugin \
	--with-smtp-plugin \
	--with-addressing-handler \
	--with-client  \
	--with-consumer %{configure_options} 

NUMCPU=`grep processor /proc/cpuinfo | wc -l`
[ $NUMCPU -eq 0 ] && NUMCPU=1;

make -j$NUMCPU

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT/%{_initrddir}
install %{SOURCE1} $RPM_BUILD_ROOT/%{_initrddir}/qcg-ntfd
install -d $RPM_BUILD_ROOT/%{_localstatedir}/log/qcg/qcg-ntf
install -d $RPM_BUILD_ROOT/%{_localstatedir}/run/qcg/qcg-ntf
install -d $RPM_BUILD_ROOT/%{_localstatedir}/lock/subsys

install -d $RPM_BUILD_ROOT/%{_logrotatedir}
install %{SOURCE2} $RPM_BUILD_ROOT/%{_logrotatedir}/qcg-ntf

rm -f $RPM_BUILD_ROOT/%{_libdir}/qcg-ntf/modules/*.la
rm -f $RPM_BUILD_ROOT/%{_libdir}/qcg-ntf/modules/*.a
rm -f $RPM_BUILD_ROOT/%{_qcgsysconfdir}/*.dist

%pre

if ! getent group | grep  -q '^qcg-dev:' /etc/group; then
        /usr/sbin/groupadd -r qcg-dev >/dev/null 2>&1
fi


if ! id -u qcg-ntf >/dev/null 2>&1; then
	%if %{system_name} == "sl5"
		%define useradd_opts -M -n -r
	%else
		%define useradd_opts -M -N -r
	%endif
        /usr/sbin/useradd %{useradd_opts} -g qcg-dev -d /var/log/qcg/qcg-ntf -s /bin/bash \
            -c "QCG-Notification Service" qcg-ntf >/dev/null 2>&1
fi


%post

touch %{_localstatedir}/log/qcg/qcg-ntf/qcg-ntfd.log
chmod 0640 %{_localstatedir}/log/qcg/qcg-ntf/qcg-ntfd.log
chown qcg-ntf:qcg-dev %{_localstatedir}/log/qcg/qcg-ntf/qcg-ntfd.log
chown qcg-ntf:qcg-dev %{_localstatedir}/log/qcg/qcg-ntf/
chown qcg-ntf:root    %{_qcgsysconfdir}/qcg-ntfd.xml


if [[ 0 -eq `/sbin/chkconfig --list qcg-ntfd 2>/dev/null | wc -l` ]] ; then

    /sbin/chkconfig --add qcg-ntfd
    echo 'Run "/sbin/service qcg-ntfd start" to start qcg-ntfd service.'
    echo
    echo 'IMPORTANT: By default it is required to configure a database to utilize more sophisticated'
    echo 'notification capabilities. The simplest way to do this is to execute a script located in'
    echo %{_datadir}'/qcg-ntf/tools/qcg-ntf-install.sh.'
    echo 'For more information see a documentation in '%{_datadir}'/qcg-ntf/doc directory.'
else
    if [ -f %{_localstatedir}/lock/subsys/qcg-ntfd ]; then
	/sbin/service qcg-ntfd restart 1>&2 || :;
    fi
fi

%preun
if [ "$1" = "0" ]; then
	if [ -f %{_localstatedir}/lock/subsys/qcg-ntfd ]; then
		/sbin/service qcg-ntfd stop 1>&2 || :;
	fi
	/sbin/chkconfig --del qcg-ntfd
	rm %{_initrddir}/qcg-ntfd || :
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/qcg-ntfd
%dir %{_datadir}/qcg-ntf
%dir %{_datadir}/qcg-ntf/doc
%doc %{_datadir}/qcg-ntf/doc/*
%dir %{_datadir}/qcg-ntf/tools
%attr(755,root,root) %{_datadir}/qcg-ntf/tools/qcg-ntf-install.sh
%attr(755,root,root) %{_datadir}/qcg-ntf/tools/qcg-ntf-update.sh
%{_datadir}/qcg-ntf/tools/qcg-ntf-psql.sql
%dir %{_datadir}/qcg-ntf/xsd
%{_datadir}/qcg-ntf/xsd/qcg-ntf.xsd
%{_datadir}/qcg-ntf/xsd/qcg-ntf-extensions.xsd
%dir %{_libdir}/qcg-ntf
%dir %{_libdir}/qcg-ntf/modules
%{_libdir}/qcg-ntf/modules/libntf-publisher-utils.so*
%{_libdir}/qcg-ntf/modules/ntf-publisher-gsoap-anonymous.so*
%{_libdir}/qcg-ntf/modules/ntf-publisher-gsoap-ssl.so*
%{_libdir}/qcg-ntf/modules/ntf-service-gsoap.so*
%dir %attr(750,root,root) %{_localstatedir}/log/qcg/qcg-ntf
%dir %attr(755,root,root) %{_localstatedir}/run/qcg/qcg-ntf
%config(noreplace) %verify(not md5 mtime size) %attr(600,root,root) %{_qcgsysconfdir}/qcg-ntfd.xml
%verify(not md5 mtime size) %attr(755,root,root) %{_initrddir}/qcg-ntfd
%dir %attr(755,root,root) %{_qcgsysconfdir}/topicns
%config(noreplace) %verify(not md5 mtime size) %attr(644,root,root) %{_qcgsysconfdir}/topicns/QCGCompNotificationTopic.xml
%config(noreplace) %verify(not md5 mtime size) %attr(644,root,root) %{_qcgsysconfdir}/topicns/QCGBrokerNotificationTopic.xml
%config(noreplace) %verify(not md5 mtime size) %attr(644,root,root) %{_qcgsysconfdir}/topicns/QCGApplicationOutputNotificationTopic.xml
%config(noreplace) %verify(not md5 mtime size) %attr(644,root,root) %{_qcgsysconfdir}/topicns/QCGSampleNotificationTopic.xml

%exclude %{_datadir}/qcg-ntf/tools/qcg-ntf-mysql.sql
%exclude %{_datadir}/qcg-ntf/tools/qcg-ntf-install-debian.sh

%files xmpp-publisher-plugin
%defattr(644,root,root,755)
%attr(644,root,root) %{_libdir}/qcg-ntf/modules/ntf-publisher-xmpp.so*

%files smtp-publisher-plugin
%defattr(644,root,root,755)
%attr(644,root,root) %{_libdir}/qcg-ntf/modules/ntf-publisher-smtp.so*

%files devel
%defattr(644,root,root,755)
%{_includedir}/qcg-ntf
%attr(755,root,root) %{_sbindir}/qcg-ntf-wsahandler
%{_datadir}/qcg-ntf/xsd/qcg-ntf-wsahandler.xsd
%{_libdir}/qcg-ntf/modules/ntf-wsahandler-gsoap.so*
%config(noreplace) %verify(not md5 mtime size) %{_qcgsysconfdir}/qcg-ntf-wsahandler.xml

%files client
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/qcg-ntf-client
%{_datadir}/qcg-ntf/xsd/qcg-ntf.xsd
%{_libdir}/qcg-ntf/modules/ntf-client-gsoap.so*
%config(noreplace) %verify(not md5 mtime size) %{_qcgsysconfdir}/qcg-ntf-client.xml

%files consumer
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/qcg-ntf-consumer
%{_datadir}/qcg-ntf/xsd/qcg-ntf-consumer.xsd
%{_libdir}/qcg-ntf/modules/ntf-consumer-gsoap.so*
%config(noreplace) %verify(not md5 mtime size) %{_qcgsysconfdir}/qcg-ntf-consumer.xml

%files logrotate
%defattr(644,root,root,755)
%config(noreplace) %attr(644,root,root) %verify(not md5 mtime size) %{_logrotatedir}/qcg-ntf 
%changelog
* Tue Mar 07 2014 Bartosz Bosak <bbosak@man.poznan.pl> 3.2.0-8
- The service run-time directory location changed to /var/run/qcg/qcg-ntf/
* Tue Jul 16 2013 Bartosz Bosak <bbosak@man.poznan.pl> 3.2.0-2
- Updated requirement for qcg-core version - 3.2.0
* Tue Jul 16 2013 Bartosz Bosak <bbosak@man.poznan.pl> 3.0.3-12
- Fixed useradd and groupadd invokes for SL5
- Added changelog
